\subsection{Lenses}

> module Lens where
>
> data Lens a b = Lens {  view :: a -> b, 
>                         update :: a -> b -> a, 
>                         create :: b -> a}
> 
> idLens :: Lens a a
> idLens = Lens (\a -> a) (\_ a -> a) (\a -> a)
> 
> compLens :: Lens b c -> Lens a b -> Lens a c
> compLens l2 l1 = Lens  (view l2 . view l1) 
>                        (\a c -> update l1 a (update l2 (view l1 a) c))
>                        (create l1 . create l2)
> 
> fstLens :: b -> Lens (a,b) a
> fstLens b = Lens fst (\(a,b) a' -> (a',b)) (\a -> (a,b))
>
> sndLens :: a -> Lens (a,b) b
> sndLens a = Lens snd (\(a,b) b' -> (a,b')) (\b -> (a,b))