\subsection{Monadic Lenses}

> module MLens where
> import Lens
>
> data MLens m a b = MLens {  mview :: a -> b, 
>                             mupdate :: a -> b -> m a, 
>                             mcreate :: b -> m a}
> 
> idMLens :: Monad m => MLens m a a
> idMLens = MLens (\a -> a) (\_ a -> return a) (\a -> return a)
> 
> compMLens :: Monad m => MLens m b c -> MLens m a b -> MLens m a c
> compMLens l2 l1 = MLens  (mview l2 . mview l1) 
>                          (\a c -> do {  b <- mupdate l2 (mview l1 a) c; mupdate l1 a b})
>                          (\c -> do {b <- mcreate l2 c ; mcreate l1 b})
> 
> lens2MLens :: Monad m => Lens a b -> MLens m a b
> lens2MLens l = MLens  (view l) 
>                       (\a b -> return (update l a b)) 
>                       (return . create l)
>

